#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>
#include <errno.h>
#include <netdb.h>

unsigned int hostname2ip( const char *hostname )
{
  struct hostent *phostent;
  unsigned int hostaddr;
  unsigned char *temp;

  phostent = gethostbyname(hostname);
  if (phostent==NULL) {
    return 0;
  }
  temp = ((unsigned char *) phostent->h_addr_list[0]);
  hostaddr = *(unsigned int*)temp;
  return hostaddr;
}

//
char *iptoa(char *dest, unsigned int ip )
{
  sprintf(dest,"%d.%d.%d.%d", 0xFF&(ip), 0xFF&(ip>>8), 0xFF&(ip>>16), 0xFF&(ip>>24));
  return dest;
}

///
char ip_string[0x40];
char *ip2string( unsigned int ip )
{
  return iptoa(ip_string, ip );
}

/////
int CreateServerSockUdp(int port)
{
  int reuse=1;
  int sock;
  struct sockaddr_in saddr;

  sock = socket(PF_INET, SOCK_DGRAM, IPPROTO_UDP);
  if (sock==-1) {
    printf("Error in INP int creation\n");
    return(-1);
  }
  saddr.sin_family = PF_INET;
  saddr.sin_addr.s_addr = htonl( INADDR_ANY );
  saddr.sin_port = htons(port);

  if (setsockopt(sock, SOL_SOCKET, SO_REUSEADDR, (char *)&reuse, sizeof(int))< 0)
  {
    close(sock);
    printf("setsockopt() failed\n");
    return -1;
  }

  if ( bind( sock, (struct sockaddr *)&saddr, sizeof(struct sockaddr_in)) == -1 ) {
    printf("Error in bind INP int\n");
    close(sock);
    return(-1);
  }

  return( sock );
}

/////
int CreateClientSockUdp()
{
  int sock;
  sock = socket(PF_INET,SOCK_DGRAM,IPPROTO_UDP);
  if (sock==-1) {
    printf("Error: socket()\n");
    return -1;
  }
  return sock;
}

///////////////////////////////////////////////////////////////////////////////
// CHECK DCW
///////////////////////////////////////////////////////////////////////////////

int checkDCW(unsigned char *data)
{
    if(data[3] != (unsigned char)((data[0] + data[1] + data[2]) & 0xFF) || data[7] != (unsigned char)((data[4] + data[5] + data[6]) & 0xFF)) {
      return 0;
    }
    if(data[11] != (unsigned char)((data[8] + data[9] + data[10]) & 0xFF) || data[15] != (unsigned char)((data[12] + data[13] + data[14]) & 0xFF)) {
      return 0;
    }
    return 1;
}


int isnullDCW(unsigned char *data)
{
   return ( (!data[0] && !data[1] && !data[2])||(!data[4] && !data[5] && !data[6]) ) && ( (!data[8] && !data[9] && !data[10])||(!data[12] && !data[13] && !data[14]) );
}

int acceptDCW(unsigned char *data)
{
	if ( checkDCW(data) && !isnullDCW(data) ) return 1;
	return 0;
}

